/*
 ͻ
   Bin2Rexx                                        last update: 2000/06/04  
   Written by Rob van der Woude                                             
   http://www.robvanderwoude.com                                            
   Convert small binaries to Rexx programs that will recreate those same    
   binaries when executed                                                   
 ͼ
*/

/* Load RexxUtil */
call RxFuncAdd "SysLoadFuncs", "RexxUtil", "SysLoadFuncs"
call SysLoadFuncs

parse source os type program
sourcedir = filespec( "D", program )||filespec( "P", program )
parse arg binfile outfile
if outfile = "" then outfile = binfile
rexxfile = strip( directory( ), "T", "\" )||"\BIN.CMD"

if argchk( binfile )  = 0 then call syntax
if argchk( rexxfile ) = 1 then call blocked rexxfile

call SysFileTree binfile, "found.", "F"
if found.0 <> 1 then do
	call syntax
	exit
end
parse value found.1 with fdate ftime fsize fattr fname

call lineout rexxfile, '/* Recreate '||filespec( "N", binfile )||' */'
call lineout rexxfile, '/* This file was created on '||date( "E" )||' '||time( "N" )||' */'
call lineout rexxfile, '/* by Bin2Rexx, (C) 1997, Rob van der Woude */'
call lineout rexxfile, ''
call lineout rexxfile, '/* Load RexxUtil */'
call lineout rexxfile, 'call RxFuncAdd "SysLoadFuncs", "RexxUtil", "SysLoadFuncs"'
call lineout rexxfile, 'call SysLoadFuncs'
call lineout rexxfile, ''
call lineout rexxfile, 'tempfile = "'||outfile||'"'
call lineout rexxfile, 'call SysFileTree tempfile, "exist.", "F"'
call lineout rexxfile, 'if exist.0 > 0 then do'
call lineout rexxfile, '    call beep 220, 250'
call lineout rexxfile, '    say ""'
call lineout rexxfile, '    say " File "||filespec( "N", tempfile )||" already exists"'
call lineout rexxfile, '    say ""'
call lineout rexxfile, '    exit'
call lineout rexxfile, 'end'
call lineout rexxfile, ''

binstr = charin( binfile, 1, min( 26, fsize ) )
call lineout rexxfile, 'call charout tempfile, "'||c2x( binstr )||'"X'

i = 1
do until chars( binfile ) = 0
	binstr = charin( binfile, ( 26 * i ) + 1, min( 26, fsize - ( i * 26 ) ) )
	call lineout rexxfile, 'call charout tempfile, "'||c2x( binstr )||'"X'
	i = i + 1
end
call lineout rexxfile, 'call lineout tempfile'
call lineout rexxfile
exit


argchk: procedure
	if strip( arg( 1 ) ) = "" then call syntax
	call SysFileTree strip( arg( 1 ) ), "exist.", "F", , "**---"
	if exist.0 = 1 then do
		chk = 1
	end
	else do
		chk = 0
	end
return chk


syntax:
	call SysCls
	call beep 220, 250
	say ""
	say " Bin2Rexx, Version 1.01 for OS/2"
	say " Written by Rob van der Woude"
	say " http://www.robvanderwoude.com"
	say ""
	say " Convert small binaries to Rexx programs that will recreate those same binaries"
	say " when executed"
	say ""
	say " Usage:"
	say "       BIN2REXX binary_in [binary_out]"
	say ""
	say " Where binary_in  is the name of the binary file to be converted"
	say "   and binary_out is the name of the binary file to be recreated"
	say "   (if binary_out is not specified, binary_in will be used)"
	say ""
	say " Example:"
	say "        BIN2REXX SAMPLE.ICO"
	say " would convert a file named SAMPLE.ICO into a Rexx program named BIN.CMD"
	say " that would, whenever executed, create an exact copy of SAMPLE.ICO"
	say ""
	say " Press any key . . ."
	call SysCurState "OFF"
	call SysGetKey "NOECHO"
	exit
return


blocked: procedure
	say ""
	say " File "||filespec( "N", arg( 1 ) )||" already exists."
	say ""
	exit
return
